unit HTTPrequest_test;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  XMLPropStorage, IdHTTP;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    IdHTTP1: TIdHTTP;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    XMLPropStorage1: TXMLPropStorage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure Connect;   {Verbinden mit dem Server}
  public

  end;

var
  Form1: TForm1;

const
  DefaultIP='192.168.35.147';
  AnzIPs=10; {zehn letzte IP Adressen in Dropdown Liste merken}

implementation

{$R *.lfm}

{ TForm1 }

{In Form1 Properties:
 - XMLPropStorage aus Misc hinzufügen, damit SessionProperties gespeichert werden
   können
 - SessionProperties alle Eigenschaften angeben, die du dir für die
   nächste Sitzung merken willst.
 - Postion: Am besten auf poDefaultPosOnly setzen.
 - ShowHint auf true für das ganze Formular, wenn du Hinweisfenster anzeigen willst
   (Beispiel Hint für ComboBox1. Du kannst sinnvolle Hints für jedes
   Eingabefeld inder Eigenschaft .Hint anlegen.
 - Mit Constrains legst du fest, wie klein oder groß das Fenster gezogen
   werden kann. Minimum sollte wenigstens so groß sein, dass keine wichtigen
   Eingabefelder oder Button weg sind --> hier 300x400 Pixel

}

{=========================== Hilfsprozedure =====================}

uses RegexPr;

function IsIPAddress(const inp: string): boolean; {Prüfen auf gültige IP Adresse}
var IPRegex: TRegExpr;
begin
  try
    IPRegex:=TRegExpr.Create;
    IPRegex.Expression:=RegExprString('\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b');
{oder hier gegebenfalls noch dein netzwerk prüfen überprüfen:
    IPRegex.Expression:=RegExprString('192.168.\b\d{1,3}\.\d{1,3}\b');}
    result:=IPRegex.Exec(inp);
  finally
    IPRegex.Free;
  end;
end;

function IsPort(p: string): string;              {Prüfen auf gültige Portnummer}
const minPortnummer=80;
      maxPortnummer=100;  {oder was weiß ich}
var port: integer;
begin
  result:='';             {Bei Fehler wird nichts zurückgegeben}
    {Umwandeln zum Testen, ob es eine Zahl ist}
  port:=StrToIntDef(trim(p), -1);   {-1, wenn die Eingabe Müll ist}
    {Testen, ob es für deine Anwendung im gültigen Portnummernbereich liegt}
  if (port>=minPortnummer) and
     (port<=maxPortnummer) then result:=IntToStr(port);  {gültiger Port}
end;


{==================== Methoden vom Formular =====================}

procedure TForm1.FormCreate(Sender: TObject);    {Formular Initialisieren}
begin
  Caption:='Test HTTP Request mit Indy10';
  ComboBox1.Items.Clear;                         {Liste löschen}
  ComboBox1.Text:=DefaultIP;
  Edit2.Text:='80';                              {Default port für HTTP}
  Edit3.Text:='';
  Edit4.Text:='';
  Memo1.Lines.Clear;
end;

procedure TForm1.Connect; {Verbinden mit dem Server, wenn alle Eingaben OK sind}
var
  HTTP: TIdHTTP;

begin
  HTTP := TIdHTTP.Create;
  try
    HTTP.Request.BasicAuthentication := True;
    HTTP.HandleRedirects := True;
    HTTP.Request.Username := Edit3.Text;
    HTTP.Request.Password := Edit4.Text;
    Memo1.Text:=HTTP.Get('http://'+ComboBox1.Text+':'+Edit2.Text);
  finally
    HTTP.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);  {Verbinden mit dem Button}
begin
  if IsIPAddress(ComboBox1.text) then begin      {IP Adresse prüfen}
    if IsPort(Edit2.Text)<>'' then begin         {Portnummer prüfen}
{IP Adresse und Port sind OK - wir wollen mal die IP in die Liste speichern}
      if ComboBox1.Items.IndexOf(ComboBox1.Text)<0 then  {wenn IP noch nicht in der Liste}
        ComboBox1.Items.Insert(0, ComboBox1.Text);       {oben eintragen}
      if ComboBox1.Items.Count>AnzIPs then ComboBox1.Items.Delete(AnzIPs); {Anzahl begrenzen}
      Connect;                                   {HTTP request ausführen}
    end else ShowMessage('Falsche Portnummer');
  end else ShowMessage('Falsches Format der IP-Adresse');
end;

end.

